/* $Id$ */
/* //////////////////////////////////////////////////////////////////////////
//                                                                         //
// This code is Copyright (c) 2008 LizardTech, Inc, 1008 Western Avenue,   //
// Suite 200, Seattle, WA 98104.  Unauthorized use or distribution         //
// prohibited.  Access to and use of this code is permitted only under     //
// license from LizardTech, Inc.  Portions of the code are protected by    //
// US and foreign patents and other filings. All Rights Reserved.          //
//                                                                         //
////////////////////////////////////////////////////////////////////////// */
/* PUBLIC */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lt_base.h"


#ifdef __cplusplus
extern "C" {
#endif

#define TEST_SUCCESS(expression) \
   do { \
      if(!LT_SUCCESS(sts = (expression))) \
         return DisplayError(sts, #expression, __FILE__, __LINE__); \
   } while(0)

#define TEST_FAILURE(expression) \
   do { \
      if(!LT_FAILURE(sts = (expression))) \
         return DisplayError(LT_STS_Failure, #expression, __FILE__, __LINE__); \
   } while(0)

#define TEST_BOOL(expression) \
   do { \
      if(!(expression)) \
         return DisplayError(LT_STS_Failure, #expression, __FILE__, __LINE__); \
   } while(0)


LT_STATUS DisplayError(LT_STATUS sts, const char *expression, const char *file, int line);

void Remove(const char* file);
int Compare(const char* file1, const char* file2);
int GetNumDiffs(const char* file1, const char* file2);
void checkCwd();

#if defined(__IPHONE_OS_VERSION_MIN_REQUIRED)
#define INPUT_PATH(filename) ("RasterExample.app/data/" filename)
#define OUTPUT_PATH(filename) ("Documents/" filename)
#else
#define INPUT_PATH(filename) ("data/" filename)
#define OUTPUT_PATH(filename) (filename)
#endif

#ifdef __cplusplus
}
#endif
